--以下、Line0->Time１に当たる。



-- Automationのindexと、parameterのindexは違うので注意。
-- （選択されたAutomationのindexは取得できない？）
-- Automation無ければ、nil、あれば選択された
-- Automationオブジェクト自体を返す。
function selected_automation()
return renoise.song().selected_pattern_track:find_automation(renoise.song().selected_parameter)
end



-- 前判定用。Automation無ければ、Create。
-- Automation有りでpoint全て消えてるときは、Delete。
function is_ini_auto ()
  local am = selected_automation()
  if am == nil
    then
      renoise.song().selected_pattern_track
      :create_automation(renoise.song().selected_parameter)
      return true
    elseif
      #am.points == 0
      then
        renoise.song().selected_pattern_track
        :delete_automation(renoise.song().selected_parameter)
        return false
      else
        return true
      end
end




--Time上の情報を返す。Point無ければ初期値、0,{}
function at_the_time (time)
  local points =
  selected_automation().points
  local index_near = 0
  local tbl = {}
  local continue = 1
  local i =1
  
  while
  continue ==1 and i <= #points do
      if
        math.abs(points[i].time - time) < 1/512
      then
        index_near = i
        tbl = points[i]
        continue =0
      else
        i=i+1
      end
  end

  return index_near,tbl
end





--あるtime最直近のpointの情報を返す。
--何もなければ、初期値0,{}を返す。
--time上にPointがあれば、その情報を返す。
function near_point (time)
  local points =
  selected_automation().points
  local index_near = 0
  local tbl = {}
  local continue = 1
  local i =1
  
  while
  continue ==1 and i <= #points do
      if
        points[i].time <= time
      then
        index_near = i
        tbl = points[i]
        i=i+1
      else
        continue =0       
      end
  end

  return index_near,tbl
end



-- time直後のPointの情報を返す。
function post_near (time)
  local points =
  selected_automation().points
  local index_near = 0
  local tbl = {}
  local continue = 1
  local i =1
  
  while
  continue ==1 and i <= #points do
      if
        points[i].time > time
      then
        index_near = i
        tbl = points[i]
        continue =0
      else
        i=i+1
      end
  end

  return index_near,tbl
end




--time以後のPointを取っ払う。
function clear_after (time)
  local points =
    selected_automation().points
  local changed ={}

  for i,p in ipairs (points) do
    if
      p.time <= time
    then
      changed[i] = p
    else
    end
  end

  selected_automation().points
  = changed
end



--time1,time2の間のPointを取っ払う。
function clear_interval (time1,time2)
  local points =
    selected_automation().points
  local changed ={}

  for i,p in ipairs (points) do
    if
      p.time <= time1 or p.time >= time2
    then
      changed[i] = p
    else
    end
  end

  selected_automation().points
  = changed
end




--timeでvalに素早くリセット
--1/256Line前に、最直近の値を残す。
function reset_at (time,val)
  local i,nearp =
    near_point (time)

  if
    i==0 or time==1
    then
      selected_automation()
      :add_point_at(time,val)
    else
      selected_automation()
      :add_point_at(((time*256 - 1)/256),nearp.value)
      
      selected_automation()
      :add_point_at(time,val)
    end
end



--timeでリセットしつつ、以後のPointを取り除く
function reset_and_clear (time,val)
  reset_at (time,val)
  clear_after (time)

end



--現在のLine編集位置でreset
function reset_at_current_line (val)
  local time =
   renoise.song().selected_line_index
  
  reset_at (time,val)
end



--Line編集位置から後のAutomationを、ValでReset＆Clear
function reset_and_clear_from_current_line (val)
  local time =
  renoise.song().selected_line_index

  reset_at (time,val)
  clear_after (time)
end


  
 -- 両Time間をClearして、両端にPointを付ける。
function add_and_clear_interval (time1,time2,val1,val2)
  reset_at (time1,val1)
  selected_automation()
      :add_point_at(time2,val2)
  clear_interval (time1,time2)
end





--timeにて、トグルで,tblに登録した値（0~1.0）順に、Point付加。
function toggl_add_point (time,tbl)
  local ini_i,ini_tbl = at_the_time (time)
  local max = #tbl
  local i =1
  local add_i =1
  local continue =1

  while continue ==1 and i <= max do
    if
      ini_i == 0
      then
        add_i = 1
        continue =0
      elseif
        math.abs(ini_tbl.value - tbl[i])<0.0001 and i < max
        then
          add_i=i+1
          continue =0
      elseif 
        math.abs(ini_tbl.value - tbl[i])<0.0001 and i == max
        then
          i = 1
          continue =0
      else
        i=i+1
      end
  end

  selected_automation()
  :add_point_at(time,tbl[add_i])
end



-- time以前の最も近いPointを一個取り去る。
-- time上にPointあれば、それを取り去る。
function del_a_point_backward (time)
  local i,t = near_point(time)
  if i==0
  then
    return nil
  else
    selected_automation():remove_point_at(t.time)
  end
end



-- timeより後の最近接Pointを一個消す。
-- time上のは無視。
function del_a_point_forward (time)
  local i,t = post_near(time)
  if i==0
  then
    return nil
  else
    selected_automation():remove_point_at(t.time)
  end
end




-- 関数fnを実行する前に、is_ini_autoで判定しておく
function with_ini (fn, val, ...)
  if is_ini_auto() == false
  then return nil
  else return fn (val, ...)
  end
end



--[[
--Keybindigs
--]]

 renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:quick reset to 0.5 in Automation",
   invoke = function()
     with_ini(reset_at,
       renoise.song().selected_line_index,
       0.50)
   end
 }
 
 
  renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:delete a point backward in Automation",
   invoke = function() 
    with_ini(del_a_point_backward,
              renoise.song().selected_line_index)
   end
 }
 
 
 
  renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:delete a point forward in Automation",
   invoke = function() 
    with_ini(del_a_point_forward,
              renoise.song().selected_line_index)
   end
 }



 renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:toggle set an automation point _1",
   invoke = function() 
    with_ini(toggl_add_point,
              renoise.song().selected_line_index,
 {0.5,13/24,14/24,15/24,16/24,17/24,18/24,19/24,20/24,21/24,22/24,23/24,1}
              )
   end
 }
 
 
 
  renoise.tool():add_keybinding {
   name = "Pattern Editor:custom shortcuts:toggle set an automation point _2",
   invoke = function() 
    with_ini(toggl_add_point,
              renoise.song().selected_line_index,
{0.5,11/24,10/24,9/24,8/24,7/24,6/24,5/24,4/24,3/24,2/24,1/24,0}
              )
   end
 }
 
 
 
